/* rygel-media-export-database.c generated by valac, the Vala compiler
 * generated from rygel-media-export-database.vala, do not modify */

/*
 * Copyright (C) 2009 Jens Georg <mail@jensge.org>.
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define RYGEL_TYPE_MEDIA_EXPORT_DATABASE (rygel_media_export_database_get_type ())
#define RYGEL_MEDIA_EXPORT_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_EXPORT_DATABASE, RygelMediaExportDatabase))
#define RYGEL_MEDIA_EXPORT_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_EXPORT_DATABASE, RygelMediaExportDatabaseClass))
#define RYGEL_IS_MEDIA_EXPORT_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_EXPORT_DATABASE))
#define RYGEL_IS_MEDIA_EXPORT_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_EXPORT_DATABASE))
#define RYGEL_MEDIA_EXPORT_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_EXPORT_DATABASE, RygelMediaExportDatabaseClass))

typedef struct _RygelMediaExportDatabase RygelMediaExportDatabase;
typedef struct _RygelMediaExportDatabaseClass RygelMediaExportDatabaseClass;
typedef struct _RygelMediaExportDatabasePrivate RygelMediaExportDatabasePrivate;
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

typedef enum  {
	RYGEL_DATABASE_ERROR_IO_ERROR,
	RYGEL_DATABASE_ERROR_SQLITE_ERROR
} RygelDatabaseError;
#define RYGEL_DATABASE_ERROR rygel_database_error_quark ()
struct _RygelMediaExportDatabase {
	GObject parent_instance;
	RygelMediaExportDatabasePrivate * priv;
};

struct _RygelMediaExportDatabaseClass {
	GObjectClass parent_class;
};

struct _RygelMediaExportDatabasePrivate {
	sqlite3* db;
};

typedef gboolean (*RygelMediaExportDatabaseRowCallback) (sqlite3_stmt* stmt, void* user_data);

static gpointer rygel_media_export_database_parent_class = NULL;

GQuark rygel_database_error_quark (void);
GType rygel_media_export_database_get_type (void);
#define RYGEL_MEDIA_EXPORT_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_TYPE_MEDIA_EXPORT_DATABASE, RygelMediaExportDatabasePrivate))
enum  {
	RYGEL_MEDIA_EXPORT_DATABASE_DUMMY_PROPERTY
};
RygelMediaExportDatabase* rygel_media_export_database_new (const char* name, GError** error);
RygelMediaExportDatabase* rygel_media_export_database_construct (GType object_type, const char* name, GError** error);
static sqlite3_stmt* rygel_media_export_database_prepare_statement (RygelMediaExportDatabase* self, const char* sql, GValue* values, int values_length1, GError** error);
gint rygel_media_export_database_exec (RygelMediaExportDatabase* self, const char* sql, GValue* values, int values_length1, RygelMediaExportDatabaseRowCallback callback, void* callback_target, GCancellable* cancellable, GError** error);
void rygel_media_export_database_analyze (RygelMediaExportDatabase* self);
void rygel_media_export_database_null (GValue* result);
void rygel_media_export_database_begin (RygelMediaExportDatabase* self, GError** error);
void rygel_media_export_database_commit (RygelMediaExportDatabase* self, GError** error);
void rygel_media_export_database_rollback (RygelMediaExportDatabase* self);
static void rygel_media_export_database_finalize (GObject* obj);



GQuark rygel_database_error_quark (void) {
	return g_quark_from_static_string ("rygel_database_error-quark");
}


#line 52 "rygel-media-export-database.vala"
RygelMediaExportDatabase* rygel_media_export_database_construct (GType object_type, const char* name, GError** error) {
#line 98 "rygel-media-export-database.c"
	GError * _inner_error_;
	RygelMediaExportDatabase * self;
	char* dirname;
	char* _tmp0_;
	char* _tmp1_;
	char* db_file;
	sqlite3* _tmp4_;
	gint _tmp3_;
	sqlite3* _tmp2_ = NULL;
	gint rc;
#line 52 "rygel-media-export-database.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 111 "rygel-media-export-database.c"
	_inner_error_ = NULL;
#line 52 "rygel-media-export-database.vala"
	self = (RygelMediaExportDatabase*) g_object_new (object_type, NULL);
#line 53 "rygel-media-export-database.vala"
	dirname = g_build_filename (g_get_user_cache_dir (), "rygel", NULL);
#line 55 "rygel-media-export-database.vala"
	g_mkdir_with_parents (dirname, 0750);
#line 56 "rygel-media-export-database.vala"
	db_file = (_tmp1_ = g_build_filename (dirname, _tmp0_ = g_strdup_printf ("%s.db", name), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 57 "rygel-media-export-database.vala"
	g_debug (_ ("Using database file %s"), db_file);
#line 58 "rygel-media-export-database.vala"
	rc = (_tmp3_ = sqlite3_open (db_file, &_tmp2_), self->priv->db = (_tmp4_ = _tmp2_, _sqlite3_close0 (self->priv->db), _tmp4_), _tmp3_);
#line 59 "rygel-media-export-database.vala"
	if (rc != SQLITE_OK) {
#line 127 "rygel-media-export-database.c"
		_inner_error_ = g_error_new (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_IO_ERROR, _ ("Failed to open database: %d (%s)"), rc, sqlite3_errmsg (self->priv->db));
		{
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (dirname);
				_g_free0 (db_file);
				g_object_unref (self);
				return NULL;
			} else {
				_g_free0 (dirname);
				_g_free0 (db_file);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 66 "rygel-media-export-database.vala"
	sqlite3_exec (self->priv->db, "PRAGMA cache_size = 32768", NULL, NULL, NULL);
#line 67 "rygel-media-export-database.vala"
	sqlite3_exec (self->priv->db, "PRAGMA synchronous = OFF", NULL, NULL, NULL);
#line 68 "rygel-media-export-database.vala"
	sqlite3_exec (self->priv->db, "PRAGMA temp_store = MEMORY", NULL, NULL, NULL);
#line 69 "rygel-media-export-database.vala"
	sqlite3_exec (self->priv->db, "PRAGMA count_changes = OFF", NULL, NULL, NULL);
#line 153 "rygel-media-export-database.c"
	_g_free0 (dirname);
	_g_free0 (db_file);
	return self;
}


#line 52 "rygel-media-export-database.vala"
RygelMediaExportDatabase* rygel_media_export_database_new (const char* name, GError** error) {
#line 52 "rygel-media-export-database.vala"
	return rygel_media_export_database_construct (RYGEL_TYPE_MEDIA_EXPORT_DATABASE, name, error);
#line 164 "rygel-media-export-database.c"
}


#line 86 "rygel-media-export-database.vala"
gint rygel_media_export_database_exec (RygelMediaExportDatabase* self, const char* sql, GValue* values, int values_length1, RygelMediaExportDatabaseRowCallback callback, void* callback_target, GCancellable* cancellable, GError** error) {
#line 170 "rygel-media-export-database.c"
	gint result = 0;
	GError * _inner_error_;
	gint rc = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 86 "rygel-media-export-database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 86 "rygel-media-export-database.vala"
	g_return_val_if_fail (sql != NULL, 0);
#line 181 "rygel-media-export-database.c"
	_inner_error_ = NULL;
#line 95 "rygel-media-export-database.vala"
	if (values == NULL) {
#line 95 "rygel-media-export-database.vala"
		_tmp1_ = callback == NULL;
#line 187 "rygel-media-export-database.c"
	} else {
#line 95 "rygel-media-export-database.vala"
		_tmp1_ = FALSE;
#line 191 "rygel-media-export-database.c"
	}
#line 95 "rygel-media-export-database.vala"
	if (_tmp1_) {
#line 95 "rygel-media-export-database.vala"
		_tmp0_ = cancellable == NULL;
#line 197 "rygel-media-export-database.c"
	} else {
#line 95 "rygel-media-export-database.vala"
		_tmp0_ = FALSE;
#line 201 "rygel-media-export-database.c"
	}
#line 95 "rygel-media-export-database.vala"
	if (_tmp0_) {
#line 96 "rygel-media-export-database.vala"
		rc = sqlite3_exec (self->priv->db, sql, NULL, NULL, NULL);
#line 207 "rygel-media-export-database.c"
	} else {
		sqlite3_stmt* statement;
#line 98 "rygel-media-export-database.vala"
		statement = rygel_media_export_database_prepare_statement (self, sql, values, values_length1, &_inner_error_);
#line 212 "rygel-media-export-database.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return 0;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return 0;
			}
		}
#line 99 "rygel-media-export-database.vala"
		while (TRUE) {
#line 225 "rygel-media-export-database.c"
			gboolean _tmp2_ = FALSE;
#line 99 "rygel-media-export-database.vala"
			if (!((rc = sqlite3_step (statement)) == SQLITE_ROW)) {
#line 99 "rygel-media-export-database.vala"
				break;
#line 231 "rygel-media-export-database.c"
			}
#line 100 "rygel-media-export-database.vala"
			if (cancellable != NULL) {
#line 100 "rygel-media-export-database.vala"
				_tmp2_ = g_cancellable_is_cancelled (cancellable);
#line 237 "rygel-media-export-database.c"
			} else {
#line 100 "rygel-media-export-database.vala"
				_tmp2_ = FALSE;
#line 241 "rygel-media-export-database.c"
			}
#line 100 "rygel-media-export-database.vala"
			if (_tmp2_) {
#line 101 "rygel-media-export-database.vala"
				break;
#line 247 "rygel-media-export-database.c"
			}
#line 104 "rygel-media-export-database.vala"
			if (callback != NULL) {
#line 105 "rygel-media-export-database.vala"
				if (!callback (statement, callback_target)) {
#line 106 "rygel-media-export-database.vala"
					rc = SQLITE_DONE;
#line 108 "rygel-media-export-database.vala"
					break;
#line 257 "rygel-media-export-database.c"
				}
			}
		}
		_sqlite3_finalize0 (statement);
	}
#line 114 "rygel-media-export-database.vala"
	if (rc != SQLITE_DONE) {
#line 114 "rygel-media-export-database.vala"
		_tmp3_ = rc != SQLITE_OK;
#line 267 "rygel-media-export-database.c"
	} else {
#line 114 "rygel-media-export-database.vala"
		_tmp3_ = FALSE;
#line 271 "rygel-media-export-database.c"
	}
#line 114 "rygel-media-export-database.vala"
	if (_tmp3_) {
#line 275 "rygel-media-export-database.c"
		_inner_error_ = g_error_new_literal (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_SQLITE_ERROR, sqlite3_errmsg (self->priv->db));
		{
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return 0;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return 0;
			}
		}
	}
	result = rc;
#line 121 "rygel-media-export-database.vala"
	return result;
#line 291 "rygel-media-export-database.c"
}


#line 138 "rygel-media-export-database.vala"
static sqlite3_stmt* rygel_media_export_database_prepare_statement (RygelMediaExportDatabase* self, const char* sql, GValue* values, int values_length1, GError** error) {
#line 297 "rygel-media-export-database.c"
	sqlite3_stmt* result = NULL;
	GError * _inner_error_;
	sqlite3_stmt* statement;
	sqlite3_stmt* _tmp2_;
	gint _tmp1_;
	sqlite3_stmt* _tmp0_ = NULL;
	gint rc;
#line 138 "rygel-media-export-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "rygel-media-export-database.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 309 "rygel-media-export-database.c"
	_inner_error_ = NULL;
	statement = NULL;
#line 142 "rygel-media-export-database.vala"
	rc = (_tmp1_ = sqlite3_prepare_v2 (self->priv->db, sql, -1, &_tmp0_, NULL), statement = (_tmp2_ = _tmp0_, _sqlite3_finalize0 (statement), _tmp2_), _tmp1_);
#line 143 "rygel-media-export-database.vala"
	if (rc != SQLITE_OK) {
#line 316 "rygel-media-export-database.c"
		_inner_error_ = g_error_new_literal (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_SQLITE_ERROR, sqlite3_errmsg (self->priv->db));
		{
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (statement);
				return NULL;
			} else {
				_sqlite3_finalize0 (statement);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 146 "rygel-media-export-database.vala"
	if (values != NULL) {
#line 333 "rygel-media-export-database.c"
		{
			gint i;
#line 147 "rygel-media-export-database.vala"
			i = 0;
#line 338 "rygel-media-export-database.c"
			{
				gboolean _tmp3_;
#line 147 "rygel-media-export-database.vala"
				_tmp3_ = TRUE;
#line 147 "rygel-media-export-database.vala"
				while (TRUE) {
#line 345 "rygel-media-export-database.c"
					GValue _tmp4_;
#line 147 "rygel-media-export-database.vala"
					if (!_tmp3_) {
#line 147 "rygel-media-export-database.vala"
						i++;
#line 351 "rygel-media-export-database.c"
					}
#line 147 "rygel-media-export-database.vala"
					_tmp3_ = FALSE;
#line 147 "rygel-media-export-database.vala"
					if (!(i < values_length1)) {
#line 147 "rygel-media-export-database.vala"
						break;
#line 359 "rygel-media-export-database.c"
					}
#line 148 "rygel-media-export-database.vala"
					if (G_VALUE_HOLDS ((_tmp4_ = values[i], &_tmp4_), G_TYPE_INT)) {
#line 363 "rygel-media-export-database.c"
						GValue _tmp5_;
#line 149 "rygel-media-export-database.vala"
						rc = sqlite3_bind_int (statement, i + 1, g_value_get_int ((_tmp5_ = values[i], &_tmp5_)));
#line 367 "rygel-media-export-database.c"
					} else {
						GValue _tmp6_;
#line 150 "rygel-media-export-database.vala"
						if (G_VALUE_HOLDS ((_tmp6_ = values[i], &_tmp6_), G_TYPE_INT64)) {
#line 372 "rygel-media-export-database.c"
							GValue _tmp7_;
#line 151 "rygel-media-export-database.vala"
							rc = sqlite3_bind_int64 (statement, i + 1, g_value_get_int64 ((_tmp7_ = values[i], &_tmp7_)));
#line 376 "rygel-media-export-database.c"
						} else {
							GValue _tmp8_;
#line 152 "rygel-media-export-database.vala"
							if (G_VALUE_HOLDS ((_tmp8_ = values[i], &_tmp8_), G_TYPE_LONG)) {
#line 381 "rygel-media-export-database.c"
								GValue _tmp9_;
#line 153 "rygel-media-export-database.vala"
								rc = sqlite3_bind_int64 (statement, i + 1, (gint64) g_value_get_long ((_tmp9_ = values[i], &_tmp9_)));
#line 385 "rygel-media-export-database.c"
							} else {
								GValue _tmp10_;
#line 154 "rygel-media-export-database.vala"
								if (G_VALUE_HOLDS ((_tmp10_ = values[i], &_tmp10_), G_TYPE_STRING)) {
#line 390 "rygel-media-export-database.c"
									GValue _tmp11_;
#line 155 "rygel-media-export-database.vala"
									rc = sqlite3_bind_text (statement, i + 1, g_strdup (g_value_get_string ((_tmp11_ = values[i], &_tmp11_))), -1, g_free);
#line 394 "rygel-media-export-database.c"
								} else {
									GValue _tmp12_;
#line 156 "rygel-media-export-database.vala"
									if (G_VALUE_HOLDS ((_tmp12_ = values[i], &_tmp12_), G_TYPE_POINTER)) {
#line 399 "rygel-media-export-database.c"
										GValue _tmp13_;
#line 157 "rygel-media-export-database.vala"
										if (g_value_peek_pointer ((_tmp13_ = values[i], &_tmp13_)) == NULL) {
#line 158 "rygel-media-export-database.vala"
											rc = sqlite3_bind_null (statement, i + 1);
#line 405 "rygel-media-export-database.c"
										} else {
#line 160 "rygel-media-export-database.vala"
											g_assert_not_reached ();
#line 409 "rygel-media-export-database.c"
										}
									} else {
										GValue _tmp14_;
										GType t;
#line 163 "rygel-media-export-database.vala"
										t = G_VALUE_TYPE ((_tmp14_ = values[i], &_tmp14_));
#line 164 "rygel-media-export-database.vala"
										g_warning (_ ("Unsupported type %s"), g_type_name (t));
#line 165 "rygel-media-export-database.vala"
										g_assert_not_reached ();
#line 420 "rygel-media-export-database.c"
									}
								}
							}
						}
					}
#line 167 "rygel-media-export-database.vala"
					if (rc != SQLITE_OK) {
#line 428 "rygel-media-export-database.c"
						_inner_error_ = g_error_new_literal (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_SQLITE_ERROR, sqlite3_errmsg (self->priv->db));
						{
							if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
								g_propagate_error (error, _inner_error_);
								_sqlite3_finalize0 (statement);
								return NULL;
							} else {
								_sqlite3_finalize0 (statement);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return NULL;
							}
						}
					}
				}
			}
		}
	}
	result = statement;
#line 173 "rygel-media-export-database.vala"
	return result;
#line 450 "rygel-media-export-database.c"
}


#line 179 "rygel-media-export-database.vala"
void rygel_media_export_database_analyze (RygelMediaExportDatabase* self) {
#line 179 "rygel-media-export-database.vala"
	g_return_if_fail (self != NULL);
#line 180 "rygel-media-export-database.vala"
	sqlite3_exec (self->priv->db, "ANALYZE", NULL, NULL, NULL);
#line 460 "rygel-media-export-database.c"
}


#line 187 "rygel-media-export-database.vala"
void rygel_media_export_database_null (GValue* result) {
#line 466 "rygel-media-export-database.c"
	GValue v = {0};
	g_value_init (&v, G_TYPE_POINTER);
#line 189 "rygel-media-export-database.vala"
	g_value_set_pointer (&v, NULL);
#line 471 "rygel-media-export-database.c"
	*result = v;
#line 191 "rygel-media-export-database.vala"
	return;
#line 475 "rygel-media-export-database.c"
}


#line 197 "rygel-media-export-database.vala"
void rygel_media_export_database_begin (RygelMediaExportDatabase* self, GError** error) {
#line 481 "rygel-media-export-database.c"
	GError * _inner_error_;
#line 197 "rygel-media-export-database.vala"
	g_return_if_fail (self != NULL);
#line 485 "rygel-media-export-database.c"
	_inner_error_ = NULL;
#line 198 "rygel-media-export-database.vala"
	if (sqlite3_exec (self->priv->db, "BEGIN", NULL, NULL, NULL) != SQLITE_OK) {
#line 489 "rygel-media-export-database.c"
		_inner_error_ = g_error_new_literal (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_SQLITE_ERROR, sqlite3_errmsg (self->priv->db));
		{
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


#line 206 "rygel-media-export-database.vala"
void rygel_media_export_database_commit (RygelMediaExportDatabase* self, GError** error) {
#line 507 "rygel-media-export-database.c"
	GError * _inner_error_;
#line 206 "rygel-media-export-database.vala"
	g_return_if_fail (self != NULL);
#line 511 "rygel-media-export-database.c"
	_inner_error_ = NULL;
#line 207 "rygel-media-export-database.vala"
	if (sqlite3_exec (self->priv->db, "COMMIT", NULL, NULL, NULL) != SQLITE_OK) {
#line 515 "rygel-media-export-database.c"
		_inner_error_ = g_error_new_literal (RYGEL_DATABASE_ERROR, RYGEL_DATABASE_ERROR_SQLITE_ERROR, sqlite3_errmsg (self->priv->db));
		{
			if (_inner_error_->domain == RYGEL_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


#line 215 "rygel-media-export-database.vala"
void rygel_media_export_database_rollback (RygelMediaExportDatabase* self) {
#line 215 "rygel-media-export-database.vala"
	g_return_if_fail (self != NULL);
#line 216 "rygel-media-export-database.vala"
	if (sqlite3_exec (self->priv->db, "ROLLBACK", NULL, NULL, NULL) != SQLITE_OK) {
#line 217 "rygel-media-export-database.vala"
		g_critical (_ ("Failed to roll back transaction: %s"), sqlite3_errmsg (self->priv->db));
#line 539 "rygel-media-export-database.c"
	}
}


static void rygel_media_export_database_class_init (RygelMediaExportDatabaseClass * klass) {
	rygel_media_export_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RygelMediaExportDatabasePrivate));
	G_OBJECT_CLASS (klass)->finalize = rygel_media_export_database_finalize;
}


static void rygel_media_export_database_instance_init (RygelMediaExportDatabase * self) {
	self->priv = RYGEL_MEDIA_EXPORT_DATABASE_GET_PRIVATE (self);
}


static void rygel_media_export_database_finalize (GObject* obj) {
	RygelMediaExportDatabase * self;
	self = RYGEL_MEDIA_EXPORT_DATABASE (obj);
	_sqlite3_close0 (self->priv->db);
	G_OBJECT_CLASS (rygel_media_export_database_parent_class)->finalize (obj);
}


GType rygel_media_export_database_get_type (void) {
	static volatile gsize rygel_media_export_database_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_media_export_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMediaExportDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_export_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaExportDatabase), 0, (GInstanceInitFunc) rygel_media_export_database_instance_init, NULL };
		GType rygel_media_export_database_type_id;
		rygel_media_export_database_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaExportDatabase", &g_define_type_info, 0);
		g_once_init_leave (&rygel_media_export_database_type_id__volatile, rygel_media_export_database_type_id);
	}
	return rygel_media_export_database_type_id__volatile;
}




